(************************************* Lagrangean *************************************)

(********************** Pure gauge terms  *************************)
LGauge = -1/4 (del[Wi[nu, i1], mu] - del[Wi[mu, i1], nu]
					-eta2 ee/sw etae/(eta2 etat) Eps[i1, i2, i3] Wi[mu, i2] Wi[nu, i3])*
					(del[Wi[nu, i1], mu] - del[Wi[mu, i1], nu]
					- eta2 ee/sw etae/(eta2 etat) Eps[i1, i4, i5] Wi[mu, i4] Wi[nu, i5]) -
					1/4 (del[B[nu], mu] - del[B[mu], nu])^2 -
					1/4 (del[G[nu, a1], mu] - del[G[mu, a1], nu] -
					eta3 gs f[a1, a2, a3] G[mu, a2] G[nu, a3])*
					(del[G[nu, a1], mu] - del[G[mu, a1], nu]  -
					eta3 gs f[a1, a4, a5] G[mu, a4] G[nu, a5]);


(********************** Pure fermion and fermion-gauge terms **********************)
LFermions = Module[{Lkin, LQCD,LBright,LBleftLEWleft,LWleft},

Lkin = I uqLbar.sibar[mu].del[uqL, mu] + I uqRbar.si[mu].del[uqR, mu] +
			I dqLbar.sibar[mu].del[dqL, mu] + I dqRbar.si[mu].del[dqR, mu] +
			I lLbar.sibar[mu].del[lL, mu] + I lRbar.si[mu].del[lR, mu] +
			I vlLbar.sibar[mu].del[vlL, mu] + I vlRbar.si[mu].del[vlR, mu] ;
LQCD = - eta3 gs (uqLbar.sibar[mu].uqL + uqRbar.si[mu].uqR + dqLbar.sibar[mu].dqL + dqRbar.si[mu].dqR) T[a] G[mu, a];

LBright = - etae B[mu] ( - ee/cw lRbar.si[mu].lR + 2ee/3/cw uqRbar.si[mu].uqR -  ee/3/cw dqRbar.si[mu].dqR);       

LBleft = - etae B[mu] (-ee/2/cw vlLbar.sibar[mu].vlL -  ee/2/cw  lLbar.sibar[mu].lL  + ee/6/cw  uqLbar.sibar[mu].uqL + ee/6/cw dqLbar.sibar[mu].dqL);

LWleft = - etae/etat ee/sw/2 (vlLbar.sibar[mu].vlL Wi[mu, 3] - lLbar.sibar[mu].lL Wi[mu, 3] +
					Sqrt[2] vlLbar.sibar[mu].lL WP[mu] + Sqrt[2] lLbar.sibar[mu].vlL WPbar[mu] +
					uqLbar.sibar[mu].uqL Wi[mu, 3] - dqLbar.sibar[mu].dqL Wi[mu, 3] +
					Sqrt[2] uqLbar.sibar[mu].CKM.dqL WP[mu] + Sqrt[2] dqLbar.sibar[mu].HC[CKM].uqL WPbar[mu]);

Lkin + LQCD + LBright + LBleft + LWleft];


(********************* Higgs Lagrangian terms*************************)
P1 = {Phi1P, Phi10};
P1bar = HC[P1];
P2 = {Phi2P, Phi20};
P2bar = HC[P2];

x1 = HC[P1].P1;
x2 = HC[P2].P2;
x3 = (HC[P1].P2 + HC[P2].P1);
x4 = HC[P1].P2;
x5 = HC[P2].P1;
m12sq=m12sqR + I m12sqI;

LHiggsKin := Block[{PMVec, WVec, Dc, Dcbar},
    
    PMVec = Table[PauliSigma[i], {i, 3}];   
    Wvec[mu_] := {Wi[mu, 1], Wi[mu, 2], Wi[mu, 3]};

	Dc[f_, mu_] := del[f, mu] +  I etae ee/2/cw  B[mu] f + I etae/etat ee/sw/2  (Wvec[mu].PMVec).f;
	Dcbar[f_, mu_] := del[f, mu] -  I etae ee/2/cw  B[mu] f - I etae/etat ee/sw/2  f.(Wvec[mu].PMVec);

    (Dcbar[P1bar, mu]).Dc[P1, mu] + (Dcbar[P2bar, mu]).Dc[P2, mu]];

 V2HDM := m11sq x1 + m22sq x2 - ( (cb sb mmusq + I m12sqI) x4 + (cb sb mmusq - I m12sqI) x5) + 
    1/2 L1 x1^2 + 1/2 L2 x2^2 + L3 x1 x2 +
    L4 x4 x5 + 1/2 (L5R + I L5I) x4^2 + 
    1/2 (L5R - I L5I) x5^2 ;

LHiggs := LHiggsKin - V2HDM;


(********************* Yukawa terms*************************)
(* We specify the type beforehand (I choose Type II).
Moreover, we replace the Yukawa matrices for mass matrices *)

LYuk := (Sqrt[2]/vv)*( -(1/(cb*(cz1+I*sz1))) uqLbar.CKM.Mdq.dqR Phi1P - (1/(cb*(cz1+I*sz1))) dqLbar.Mdq.dqR Phi10 +
						(1/(sb*(cz2-I*sz2))) dqLbar.HC[CKM].Muq.uqR Phi2Pbar - (1/(sb*(cz2-I*sz2))) uqLbar.Muq.uqR Phi20bar -
						(1/(cb*(cz1+I*sz1))) vlLbar.Ml.lR Phi1P - (1/(cb*(cz1+I*sz1))) lLbar.Ml.lR Phi10)
LYukawa := LYuk + HC[LYuk];


(********************** Ghost terms **********************)
LGhost := Block[{dBRSTG,LGhostG,dBRSTWi,LGhostWi,dBRSTB,LGhostB},
		
dBRSTG[mu_,a_] :=  Module[{a2, a3}, - del[ghG[a], mu] + eta3 gs f[a,a2,a3] G[mu,a2] ghG[a3]];
LGhostG := ghGbar[a].del[dBRSTG[mu,a],mu];
	
dBRSTWi[mu_,i_] := Module[{i2, i3}, - del[ghWi[i], mu] + eta2 ee/sw  etae/eta2/etat Eps[i,i2,i3] Wi[mu,i2] ghWi[i3]];
LGhostWi := ghWibar[a].del[dBRSTWi[mu,a],mu];   
	
dBRSTB[mu_] := - del[ghB, mu];
LGhostB :=  ghBbar.del[dBRSTB[mu],mu];

GhostVector:={ghWp,ghWm,ghZ,ghA};
GhostVectorbar:={ghWpbar,ghWmbar,ghZbar,ghAbar};

(* Note that, strictly speaking, we should be careful with the phases in the Ghost sector.
However, since this is only relevant for renormalization ourposes, and since we do not intend
to renormalize this sector, we neglect this topic in this sector *)

DFiDalphaj:={
		{(eta2 I MW xiW ) (eta2 I/2 ee/sw etae/(eta2 etat) (cb (v1 + r1 + I e1) + sb (v2 + r2 + I e2))),0,
		(eta2 I MW xiW) (eta2 I/2 ee (cw/sw-sw/cw) etae/(eta2 etat) etaZ (cb phi1P+ sb phi2P)),
		(eta2 I MW xiW) (I ee etae ) (cb phi1P+sb phi2P)},
		{0,(-eta2 I MW xiW) (-eta2 I/2 ee/sw etae/(eta2 etat) ( cb (v1 + r1 - I e1)+sb (v2 + r2 - I e2))),
		(-eta2 I MW xiW) (-eta2 I/2 ee (cw/sw-sw/cw) etae/(eta2 etat) etaZ (cb phi1Pbar+ sb phi2Pbar)),
		(-eta2 I MW xiW) (-I ee etae) (cb phi1Pbar+sb phi2Pbar)},
		{(eta2 etaZ MZ xiZ) (1/2) eta2  etae/(eta2 etat) ee/sw (cb phi1Pbar+ sb phi2Pbar),  
		(eta2 etaZ MZ xiZ) (1/2) eta2 ee/sw etae/(eta2 etat) (cb phi1P + sb phi2P), 
		(eta2 etaZ MZ xiZ) (-1) eta2 ee/2/sw/cw etae/(eta2 etat) etaZ (cb (v1 + r1)+ sb (v2 + r2)), 0},
		{0,0,0,0}};

 LGhostphi:= DFiDalphaj[[1,1]] ghWpbar ghWp +
			DFiDalphaj[[1,2]] ghWpbar ghWm +
			DFiDalphaj[[1,3]] ghWpbar ghZ +
			DFiDalphaj[[1,4]] ghWpbar ghA +

			DFiDalphaj[[2,1]] ghWmbar ghWp +
			DFiDalphaj[[2,2]] ghWmbar ghWm +
			DFiDalphaj[[2,3]] ghWmbar ghZ +
			DFiDalphaj[[2,4]] ghWmbar ghA +

			DFiDalphaj[[3,1]] ghZbar ghWp +
			DFiDalphaj[[3,2]] ghZbar ghWm +
			DFiDalphaj[[3,3]] ghZbar ghZ +
			DFiDalphaj[[3,4]] ghZbar ghA;

LGhostG + LGhostWi + LGhostB + LGhostphi]


(********************** Gauge Fixing terms **********************)
(* Note that, strictly speaking, we should be careful with the phases in the Gauge Fixing sector.
However, since this is only relevant for renormalization ourposes, and since we do not intend
to renormalize this sector, we neglect this topic in this sector *)
FixG[a_] := del[G[mu, a], mu]
FixA := del[A[mu], mu]
FixZ := del[Z[mu],mu] + eta2 etaZ xiZ MZ (cb e1 + sb e2)
FixWP := del[WP[mu],mu] + I xiW eta2 MW (cb phi1P+ sb phi2P)
FixWM := del[WPbar[mu],mu] - I xiW eta2 MW (cb phi1Pbar + sb phi2Pbar)

LGFG := -1/2/xiG FixG[a] FixG[a]
LGFA := -1/2/xiA FixA FixA
LGFZ := -1/2/xiZ FixZ FixZ
LGFW := -1/xiW FixWP FixWM

LGF := LGFG + LGFA + LGFZ + LGFW

