(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
This is the FeynMaster model file for the Standard Model.
Created by: Duarte Fontes
Email: duartefontes@tecnico.ulisboa.pt
Last Update: 30.07.2020
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)

(******* Index definitions ********)
IndexRange[Index[Generation]] = Range[3]
IndexRange[Index[Colour]] = NoUnfold[Range[3]]
IndexRange[Index[Gluon]] = NoUnfold[Range[8]]
IndexRange[Index[SU2W]] = Unfold[Range[3]]

IndexStyle[Colour,i]
IndexStyle[Generation,f]
IndexStyle[Gluon,a]
IndexStyle[SU2W,k]

(******* Gauge Groups *******)
M$GaugeGroups = {
  U1Y == {
        Abelian -> True,
        GaugeBoson -> B,
        Charge -> Y,
        CouplingConstant -> g1},
  SU2L == {
        Abelian -> False,
        GaugeBoson -> Wi,
        StructureConstant -> Eps,
        CouplingConstant -> gw},
  SU3C == {
        Abelian -> False,
        GaugeBoson -> G,
        StructureConstant -> f,
        SymmetricTensor -> dSUN,
        Representations -> {T, Colour},
        CouplingConstant -> gs}
}

Get["Parameters.fr"];
Get["ParticleClasses.fr"];
Get["Lagrangean.fr"];
Get["Extra.fr"];